# Import libraries.
import numpy as np
import math

def create_descriptor_idx_vector(descriptor_set):
    
    # Folders.
    folder_data = "../data"

    # Specify indices and index ranges for different descriptors.
    idx_porosity = np.array([0])
    
    idx_spec_surf = np.array([1])
    
    idx_constrictivity = np.array([2])
    
    idx_r_min = np.array([3])
    idx_r_max = np.array([4])
    
    idx_geod_tort_mean = np.array([5])
    idx_geod_tort_std = np.array([6])
    idx_geod_tort_dist = np.arange(7, 26)
    
    idx_chord_length_mean = np.array([26])
    idx_chord_length_std = np.array([27])
    idx_chord_length_dist = np.arange(28, 47)
    
    idx_spherical_contact_mean = np.array([47])
    idx_spherical_contact_std = np.array([48])
    idx_spherical_contact_dist = np.arange(49, 68)
    
    idx_corr_fun = np.array(range(68, 236))
    
    # Define descriptor sets.
    if descriptor_set == 1:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_spec_surf, 
                                            idx_geod_tort_mean), axis = 0)
    if descriptor_set == 2:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_spec_surf, 
                                            idx_geod_tort_mean, 
                                            idx_constrictivity), axis = 0)
    if descriptor_set == 3:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_geod_tort_mean, 
                                            idx_geod_tort_std), axis = 0)
    if descriptor_set == 4:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_geod_tort_mean, 
                                            idx_constrictivity), axis = 0)
    if descriptor_set == 5:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_geod_tort_mean, 
                                            idx_r_min), axis = 0)
    if descriptor_set == 6:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_geod_tort_mean, 
                                            idx_r_min, 
                                            idx_r_max), axis = 0)
    if descriptor_set == 7:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_geod_tort_mean, 
                                            idx_r_min,
                                            idx_constrictivity, 
                                            idx_chord_length_mean), axis = 0)
    if descriptor_set == 8:
        idx_descriptors = np.concatenate((  idx_porosity,
                                            idx_spec_surf, 
                                            idx_geod_tort_mean, 
                                            idx_geod_tort_std, 
                                            idx_geod_tort_dist), axis = 0)
    if descriptor_set == 9:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_spec_surf, 
                                            idx_chord_length_mean, 
                                            idx_chord_length_std, 
                                            idx_chord_length_dist), axis = 0)
    if descriptor_set == 10:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_spec_surf, 
                                            idx_spherical_contact_mean, 
                                            idx_spherical_contact_std, 
                                            idx_spherical_contact_dist), axis = 0)
    if descriptor_set == 11:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_spec_surf, 
                                            idx_corr_fun), axis = 0)
    if descriptor_set == 12:
        idx_descriptors = np.concatenate((  idx_porosity, 
                                            idx_spec_surf, 
                                            idx_constrictivity,
                                            idx_r_min,
                                            idx_r_max,
                                            idx_geod_tort_mean, 
                                            idx_geod_tort_std, 
                                            idx_geod_tort_dist,
                                            idx_chord_length_mean, 
                                            idx_chord_length_std, 
                                            idx_chord_length_dist, 
                                            idx_spherical_contact_mean, 
                                            idx_spherical_contact_std, 
                                            idx_spherical_contact_dist, 
                                            idx_corr_fun), axis = 0)
    
    return idx_descriptors
